use std::fmt::Write;
use dim_sdk::{plugin_info, Context, DimPlugin};

plugin_info!(
    Plug,                    // Your main global structs name that implements `DimPlugin`
    "example_rust",          // Plugin name
    "0.0.0",                 // Plugin Version (leave empty for none)
    "GPLv3"                  // Plugin license (leave empty for none)
    );

struct Plug {
    counter: usize,
}

impl Plug {
    pub fn new() -> Self {
        Self {
            counter: 0
        }
    }
}

impl DimPlugin for Plug {
    fn init(&mut self, _ctx: Context) {
        // Initialise data, this will run once, it will not run again after reload
    }
    fn poll(&mut self, f: &mut dim_sdk::CBuffer) -> dim_sdk::Result<()> {
        // Write to buffer the text you want to display, keep this short
        write!(f, "Hello from rust! ({})", self.counter)?;
        self.counter += 1;
        Ok(())
    }
    fn pre_reload(&mut self) {
        // Do stuff before reload, probably save important things because theres a good chance
        // (especially on rust) that if you change the data layout it will die
    }
    fn post_reload(&mut self) {
        // Do stuff after reloading plugin, state a.k.a this struct has the same data, will crash
        // if the data layout changed
    }
    fn free(&mut self) {
        // Yout probably dont need this but its for freeing things before the plugin gets unloaded
    }
}




